#include "flash_plugin.h"

Flash_plugin::Flash_plugin()
{
    name = "flashplayer";
    genericName = "Flash Animation";
    icon = QIcon("/usr/share/pixmaps/flashplayer.png");
}

QString Flash_plugin::getName()
{
    return name;
}

QString Flash_plugin::getGenericName()
{
    return genericName;
}

QIcon Flash_plugin::getIcon()
{
    return icon;
}

QString Flash_plugin::getCommand()
{
    return name + " " + command;
}

void Flash_plugin::getPluginConfig(QVBoxLayout *info)
{
    lblPath = new QLabel("Select a file :");
    txtPath = new QLineEdit();
    btnFile = new QPushButton();
    QHBoxLayout *layout = new QHBoxLayout();

    btnFile->setIcon(QIcon::fromTheme("folder"));
    connect(btnFile,SIGNAL(clicked()),this,SLOT(on_file_selected()));
    layout->addWidget(lblPath);
    layout->addWidget(txtPath);
    layout->addWidget(btnFile);

    info->addLayout(layout);

    txtPath->setText("/cdrom/flash/flashexample.swf");
}

Plugin* Flash_plugin::writeConfig()
{
    command = txtPath->text();
    QString newFile = "[" + name + "]\n"
              "path=" + txtPath->text() + "\n";
    newFile += "\n";

    QFile file(CONFFILE);
    if(file.open(QFile::ReadWrite |
                  QFile::Text))
    {
        bool keep = true;
        QTextStream in(&file);
        while (!in.atEnd())
        {
          QString line = in.readLine();
          if(line == "[" + name + "]")
              keep = false;
          if(keep)
              newFile += line + "\n";
          if(line == "")
              keep = true;

        }
        file.close();
        if(file.open(QFile::WriteOnly | QIODevice::Truncate |
                      QFile::Text))
        {
            QTextStream out(&file);
            out << newFile;
            file.flush();
            file.close();
        }
    }

    return this;
}

void Flash_plugin::readConfig()
{
    QFile file(CONFFILE);
    if(file.open(QFile::ReadOnly |
                  QFile::Text))
    {
        bool parse = false;
        QTextStream in(&file);
        while (!in.atEnd())
        {
          QString line = in.readLine();
          if(line == "")
              parse = false;
          if(line == "[" + name + "]")
              parse = true;

          QStringList list = line.split("=");
          if((list.at(0) == "path") && parse)
          {
              txtPath->setText(list.at(1));
          }
        }
        file.close();
    }
}

void Flash_plugin::on_file_selected()
{
    QString fileName = QFileDialog::getOpenFileName(0,"Open file",QDir::homePath());
    if(fileName != "")
        txtPath->setText(fileName);
}
